#include "ElementVectors.h"
#include "ElementVectors.hpp"
using namespace tbox;

template class ElementVectors<double, static_cast<int>(ElType::TRI3), 3>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::TRI3), 3>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::TRI3), 3>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 24, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::TRI3), 3>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::TRI3), 3>;

template class ElementVectors<double, static_cast<int>(ElType::QUAD4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::QUAD4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::QUAD4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 24, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::QUAD4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::QUAD4), 4>;

template class ElementVectors<double, static_cast<int>(ElType::TETRA4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::TETRA4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::TETRA4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 24, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::TETRA4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::TETRA4), 4>;

template class ElementVectors<double, static_cast<int>(ElType::HEX8), 8>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::HEX8), 8>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::HEX8), 8>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 24, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::HEX8), 8>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>,
                              static_cast<int>(ElType::HEX8), 8>;
