function [x_new, S_nu] = richardsonSmoother(x_old,A,b,omega,nu)

    I = eye(size(A));
    S = I-omega*A;
    g = omega*b;
    
    for i=1:nu
        x_new = S*x_old+g;
        x_old = x_new;
    end
    
    S_nu = S^nu;
end
   